<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 41.65 Filter User</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
     <!-- Import Datatable sau jquery -->
     <!-- Import them style bootstrap cho datatable -->
     <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
     <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
     <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>
<body>
     <div class="container">
          <h2 style="text-align: center;">Danh sách đơn hàng</h2>
          <div class="jumbotron container">
               <div class="form-group row">
                    <div class="col-md-5 row">
                         <div class="col-md-6 text-center">
                              <label class="form-group mx-2">Trạng thái oder</label>
                         </div>
                         <div class="col-md-6">
                              <select class="form-control" id="select-status">
                                   <option value="all">All</option>
                                   <option value="open">Open</option>
                                   <option value="confirmed">Confirmed</option>
                                   <option value="cancel">Cancel</option>
                              </select>
                         </div>
                    </div>
                    <div class="col-md-5 row">
                          <div class="col-md-6 text-center">
                              <label class="form-group mx-2">Loại Pizza</label>
                         </div>
                         <div class="col-md-6">
                              <select class="form-control" id="select-pizza">
                                   <option value="all">All</option>
                                   <option value="hawaii">Hawaii</option>
                                   <option value="bacon">Bacon</option>
                                   <option value="seafood">Seafood</option>
                              </select>
                         </div>
                    </div>
                    <div class="col-md-2 row">
                         <div class="col-md-12 text-right">
                              <button class="btn btn-success" id="btn-filter">Lọc</button>
                         </div>
                    </div>
               </div>
          </div>
          <table class="table table-bordered table-striped table-hover" id="table-order">
               <thead>
                    <tr>
                         <th>Order Code</th>
                         <th>Kích cỡ combo</th>
                         <th>Loại Pizza</th>
                         <th>Nước uống</th>
                         <th>Thành Tiền</th>
                         <th>Họ và tên</th>
                         <th>Số điện thoại</th>
                         <th>Trạng thái</th>
                         <th>Action</th>
                    </tr>
               </thead>
          </table>
     </div>

     <!--vùng modal-->
     <div class="modal fade text-center" id="modal-order" tabindex="-1" role="dialog">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">ORDER DETAIL</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <!--FORM THIẾT KẾ NHƯ BÌNH THƯỜNG -->
                  <form>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Order Code</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-order-code" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Pizza Size</label>
                              </div>
                              <div class="col-md-10">
                                   <select id="select-pizza-size" class="form-control" type="select"> </select> 
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Đường kính</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-duong-kinh" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Sườn</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-suon" class="form-control" type="text"> 
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Salad</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-salad" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Pizza Type</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-pizza-type" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">ID Voucher</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-id-voucher" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Thành tiền</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-thanh-tien" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Giảm giá</label>
                              </div>
                              <div class="col-md-10">
                                   <input id="inp-giam-gia" class="form-control" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Loại đồ uống</label>
                              </div>
                              <div class="col-md-10">
                                   <select id="select-drink" class="form-control" type="select"></select>
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Số lượng nước uống</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-so-luong-nuoc-uong" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Họ và tên</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-ho-va-ten" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Email</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-email" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Số điện thoại</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-so-dien-thoai" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Địa chỉ</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-dia-chi" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Lời nhắn</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-loi-nhan" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Ngày order</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-ngay-order" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-md-2">
                                   <label for="">Ngày chỉnh sửa</label>
                              </div>
                              <div class="col-md-10">
                                  <input class="form-control" id="inp-ngay-chinh-sua" type="text">
                              </div>
                         </div>
                         <div class="form-group row">
                              <div class="col-sm-6 form-group">
                                  <button class="col-sm-12 btn btn-warning" id = "btn-confirm">Confirm</button>
                              </div>
                              <div class="col-sm-6">
                                  <button class="col-sm-12 btn btn-danger" id="btn-cancel">Cancel</button>
                              </div>
                         </div>
                  </form>
              </div>
              <div class="modal-footer">
                <button id="btn-modal-close" type="button" class="btn btn-primary" data-dismiss="modal">Close</button>
              </div>
            </div>
          </div>
        </div>
</body>

<script>
     "use strict"
     $(document).ready(function(){
          /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
          var gID;
          var gOrderCode;
          var gPizzaType = ["S", "M", "L"];
          var gDataOrders = []; //khai báo mảng (biến toàn cục) để chứa thông tin đơn hàng
          const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
          //khai báo các cột datatable
          const gCOL_ORDER_CODE = 0;
          const gCOL_KICH_CO = 1;
          const gCOL_LOAI_PIZZA = 2;
          const gCOL_ID_LOAI_NUOC_UONG = 3;
          const gCOL_THANH_TIEN = 4;
          const gCOL_HO_TEN = 5;
          const gCOL_SO_DIEN_THOAI = 6;
          const gCOL_TRANG_THAI = 7;
          const gCOL_ACTION = 8;

          //đinh nghĩa table chưa có data
          $("#table-order").DataTable({
               "columns": [
                    {"data": gORDER[gCOL_ORDER_CODE]},
                    {"data": gORDER[gCOL_KICH_CO]},
                    {"data": gORDER[gCOL_LOAI_PIZZA]},
                    {"data": gORDER[gCOL_ID_LOAI_NUOC_UONG]},
                    {"data": gORDER[gCOL_THANH_TIEN]},
                    {"data": gORDER[gCOL_HO_TEN]},
                    {"data": gORDER[gCOL_SO_DIEN_THOAI]},
                    {"data": gORDER[gCOL_TRANG_THAI]},
                    {"data": gORDER[gCOL_ACTION]}
               ],
               //ghi đè nội dung của cột action, chuyển thành  nút chi tiết 
               "columnDefs": [
                    {
                         "targets": gCOL_ACTION,
                         "defaultContent": "<button class = 'btn btn-primary btn-detail'>Chi tiết</button>"
                    }
               ]
          })

          /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
          //gọi hàm xử lý việc tải trang
          onPageLoading();

          //gọi hàm hiển thị danh sách đồ uống vào select
          getDrinkListAjaxClick();

          //gọi hàm hiển thị kích cỡ pizza size vào select
          getPizzaSizeListAjaxClick(gPizzaType);

          //gán sự kiện cho nút chi tiết 
          $("#table-order").on("click", ".btn-detail", function(){
               onBtnChiTietClick(this); //this là button được ấn 
          });

          //gán sự kiện click cho nút lọc
          $("#btn-filter").on("click", function(){
               onBtnFilterLocClick(); 
          });
          /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
          //hàm xử lý việc tải trang
          function onPageLoading(){
               //lấy data từ sever
               $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
                    type: "GET", 
                    dataType: "json",
                    success: function(res){
                         gDataOrders = res;
                         console.log(gDataOrders);

                         //gọi hàm loadData đổ dữ liệu vào bảng 
                         loadDataToTable(res);
                    }, 
                    error: function(err){
                         console.assert(err.responseText);
                    }

               });
          }
          /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */

          //hàm load dữ liệu vào bảng 
          function loadDataToTable(paramResObj){
               "use strict";
               var vUserTable = $("#table-order").DataTable();
               //xóa toàn bộ dữ liệu đang có của bảng
               vUserTable.clear();
               //cập nhật dâta cho bảng 
               vUserTable.rows.add(paramResObj);
               // cập nhật lại giao diện hiển thị bảng 
               vUserTable.draw();
          }

          //hàm xử lý khi ấn nút chi tiết 
          function onBtnChiTietClick(paramChiTietBtn){
               "use strict";
               var vRowSelected = $(paramChiTietBtn).closest("tr");
               var vTable = $("#table-order").DataTable();
               var vDataRow = vTable.row(vRowSelected).data();
               gID = vDataRow.id;
               gOrderCode = vDataRow.orderCode;
               console.log("ID: " + gID);
               console.log("Order Code: " + gOrderCode);
               getAjaxDetailOrder(gOrderCode);    
               // console.log(gOrderCode);
               $("#modal-order").modal("show");
          }

           //hàm filter(lọc) data
          function onBtnFilterLocClick(){
               "use strict";
               var vStatus = $("#select-status").val();
               var vPizzaType = $("#select-pizza").val();
               // console.log(vStatus);
               // console.log(vPizzaType);
                    var vDataFilter = gDataOrders.filter(function (paramOrder, index){
                         return (vStatus === "all" || (paramOrder.trangThai && vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase()))
                              && (vPizzaType === "all" || (paramOrder.loaiPizza && vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase()))
               });  

               //gọi hàm load đổ dữ liệu vào bảng 
               loadDataToTable(vDataFilter);
          }

          //hàm xử lý việc load danh sách đồ uống
          function getDrinkListAjaxClick(){
               "use strict";
               $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
                    type: "GET", 
                    dataType: 'json',
                    success: function(res){
                         handlerDrinkList(res);
                    },
                    error: function(error){
                         alert(error.responseText);
                    }
               });
          }

          //hàm tạo option cho select đồ uống 
          function handlerDrinkList(paramDrink){
               "use strict";
               $.each(paramDrink, function(i, item){
                    $("#select-drink").append($('<option>', {
                         text: item.tenNuocUong,
                         value: item.maNuocUong
                    }))
               })
          }

          //hàm tạo option cho select pizza size
          function getPizzaSizeListAjaxClick(paramPizza){
               "use strict";
               $.each(paramPizza, function(i, item){
                    $("#select-pizza-size").append($('<option>', {
                         text: item,
                         value: item.toLowerCase()
                    }))
               })
          }

          //hàm gọi api order theo ordercode
          function getAjaxDetailOrder(paramOrderCode){
               "use strict";
               $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + paramOrderCode,
                    dataType: "json",
                    type: "GET", 
                    success: function(paramOrder){
                         //ghi thông tin order tìm được ra cônsle
                         console.log(paramOrder);
                         //gọi hàm hiển thị thông tin đơn hàng lên modal
                          handlerOrderDetail(paramOrder);
                    }, 
                    error: function(ajaxContext){
                         alert(ajaxContext.responseText);
                    }
               });
          }

          // //hàm đổ dữ liệu vào modal
          function handlerOrderDetail(paramRes){
               "use strict";
               $("#inp-order-code").val(paramRes.orderCode);
               $("#select-pizza-size").val(paramRes.kichCo.toLowerCase());
               $("#inp-duong-kinh").val(paramRes.duongKinh);

              
               
              
               $("#inp-pizza-type").val(paramRes.loaiPizza);
               $("#inp-id-voucher").val(paramRes.idVourcher);
               $("#inp-suon").val(paramRes.suon);
               $("#inp-salad").val(paramRes.salad);
               $("#inp-giam-gia").val(paramRes.giamGia);
               $("#inp-thanh-tien").val(paramRes.thanhTien);
               $("#select-drink").val(paramRes.idLoaiNuocUong);
               $("#inp-so-luong-nuoc-uong").val(paramRes.soLuongNuoc);


               $("#inp-ho-va-ten").val(paramRes.hoTen);
               $("#inp-email").val(paramRes.email);
               $("#inp-so-dien-thoai").val(paramRes.soDienThoai);
               $("#inp-dia-chi").val(paramRes.diaChi);
               $("#inp-loi-nhan").val(paramRes.loiNhan);


               $("#inp-ngay-order").val(paramRes.ngayTao);
               $("#inp-ngay-chinh-sua").val(paramRes.ngayCapNhat);
              

               
          }
     });

</script>
</html>